


#ifndef __CLIENT_H__
#define __CLIENT_H__


#include "P4Item.h"
#include "IUpdateable.h"


namespace Perforce {


class Client;
typedef QList< Client > ClientList;

class Client : public P4Item {

public:

  static const ClientList& getClients();
  
  inline const QString&  getOwner() const { return _owner; }
  inline const QString&  getHost() const  { return _host; }
  inline const QString&  getRoot() const  { return _root; }

private:  

  Client() { }

  QString _owner;
  QString _host;
  QString _root;

  struct ClientListCache : public IUpdateable< ClientList > {    
    void OutputStat( StrDict* varList );    
    void HandleError( Error* err );    
    void updateCache();       
  };  


  friend ClientListCache;

  static ClientListCache _clientListCache;
};


}

#endif