

#ifndef __CONNECTION_INFO_H__
#define __CONNECTION_INFO_H__


#include "clientapi.h"
#include "P4Item.h"

namespace Perforce {



class ConnectionInfo : public P4Item
{  

public:

  static const ConnectionInfo getConnectionInfo();
    

  const QString& getClientName() const { return _name; }
  const QString& getClientHost() const { return _host; }
  const QString& getClientRoot() const { return _root; }
  const QString& getCurrentDir() const { return _currentDir; }
  const QString& getClientAddress() const { return _clientAddress; }
  const QString& getServerAddress() const { return _serverAddress; }
  const QString& getServerRoot() const { return _serverRoot; }
  const QString& getUserName() const { return _userName; }

  // const QDateTime& getServerDate() const { return _date; }
  const QString& getStringDate() const { return _stringDate; }

  const QString& getServerVersion() const { return _serverVersion; }
  const QString& getServerLicense() const { return _description; }
  
  const QString toString() const;

private:

  ConnectionInfo() { }

  QString _host;
  QString _root;
  QString _currentDir;
  QString _clientAddress;
  QString _serverAddress;
  QString _serverRoot;
  QString _serverVersion;

  QString _stringDate;
  QString _userName;

  struct ConnectionInfoUI : public ClientUser  {
    ConnectionInfo* _info;
    ConnectionInfoUI() { _info = NULL; }
    void HandleError( Error* err );    
    const ConnectionInfo getConnectionInfo();
    void OutputInfo( char level, char* msg );    
  };


  friend ConnectionInfoUI;

  static ConnectionInfoUI _connectionInfoUI;

};

} // end namespace

#endif
