


#ifndef __DEPOT_TREE_H__
#define __DEPOT_TREE_H__

#include "clientapi.h"
#include "Isyncable.h"
#include "Depot.h"
#include "DirEntry.h"

#include <qlistview.h>
#include <qlist.h>

class DepotTree : public QListView, ISyncable {

  Q_OBJECT

public:

  DepotTree( QWidget* parent = 0, const char* name = 0 );    
  void refresh();  

public slots:

  void slotExpanded( QListViewItem* item );

private:

  Perforce::DepotList _depots;

  void updateDepotEntry( QListViewItem* item );
  void updateDirEntry( QListViewItem* item );
  void appendDirEntries( QListViewItem* item, Perforce::DirEntryList );
  void appendFileEntries( QListViewItem* item, Perforce::FileEntryList );

};

#endif

