


#ifndef __JOB_H__
#define __JOB_H__

#include "P4Item.h"
#include "IUpdateable.h"

namespace Perforce {

class Job;
typedef QList< Job > JobList;

class Job : public P4Item {

public:
  
  inline const QString& getStatus() const
    { return _status; }

  inline const QString& getReportedBy() const 
    { return _reportedBy; }

  inline const QDateTime& getReportDate() const 
    { return P4Item::getDate(); } 

public:

  static const JobList& getJobs();  

private:

  Job() { }
  
  QString   _status;
  QString   _reportedBy;  


private:

  struct JobListCache : IUpdateable< Perforce::JobList > {
    void HandleError( Error* err );
    void OutputStat( StrDict* varList );
    void updateCache();       
  };

  friend JobListCache;

  static JobListCache _joblistCache;
};


} // end namespace

#endif
