//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
#ifndef __JOB_MENU_H__
#define __JOB_MENU_H__

#include "IUpdateable.h"
#include "Job.h"
#include "WidgetId.h"

#include <qlistview.h>
#include <qpixmap.h>
#include <qpopupmenu.h>


class JobTable;

class JobMenu : public QPopupMenu
{
  Q_OBJECT

public:

	JobMenu( QWidget* parent = 0, const char* name = 0 );
	virtual ~JobMenu(); 
  void setListView( JobTable* t );

  typedef void (JobMenu::*JobMenuFuncPtr)();

public slots:

  void slotViewJobs();
  void _viewJobs();

	void slotSetJobListColumn();
	void slotClearFilter();
	void slotFilter();
	void slotDelete();
	void slotDescribe();
	void slotEditSpec();
	void slotNew();

signals:

  void showJobs( WidgetId );

private:

  JobTable* _joblistTable;
};



class JobTable : public QListView {

public:

  JobTable( QWidget* parent = 0, const char* name = 0 );
  void addJob( const Perforce::Job* j );

};


#endif 

