


#ifndef __LABEL_H__
#define __LABEL_H__

#include "P4Item.h"
#include "IUpdateable.h"

namespace Perforce {

class Label;
typedef QList< Label > LabelList;

class Label : public P4Item {

public:

  static const LabelList& getLabels();
  
  inline const QString& getOwner() const  { return _owner; }
  inline const QString& getStatus() const { return _status; } 

private:

  Label() { }
  
  QString _owner;
  QString _status; 

private:

  struct LabelCache : IUpdateable< LabelList > {
    void HandleError( Error* err );
    void OutputStat( StrDict* varList );
    void updateCache();
  };

  friend LabelCache;

  static LabelCache _labelCache;

};


} // end namespace


#endif
