//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
#ifndef __P4_PROCESS_H__
#define __P4_PROCESS_H__

#include "BranchSpec.h"
#include "Job.h"
#include "Change.h"
#include "User.h"

#include <qstring.h>
#include <qstringlist.h>

#include "perforce/clientapi.h"

// if this ever moves to qt 3.x, then this class should inherit 
// QProcess.
class P4Process  
{

public:

	P4Process();
	virtual ~P4Process();       

  void exec( const QString& args, bool forceSupressOutput = false );

  inline const QStringList& getCommandStdOutput() const;

private:  

  QStringList _cmdStdOutput;

#ifdef WIN32
  void _win32Exec( const QString& args );
#endif

};


inline const QStringList& P4Process::getCommandStdOutput() const
{
  return _cmdStdOutput;
}


#endif 

