

#ifndef __SERVER_THREAD_H__
#define __SERVER_THREAD_H__

#include <qthread.h>

//===========================================================
//
// asynchronous access to the p4 server.
//
template< typename OBJECT, typename MEMBERFUNC >
struct ServerThread : public QThread {  
  OBJECT* object;  
  MEMBERFUNC function;

  ServerThread( OBJECT* obj, MEMBERFUNC func ) :
    object( obj ),
    function( func ) { start(); }

  void run() { 
    qDebug( "Running server thread." );
    ((*object).*function)();
    delete this;
  }
};


#endif
