//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
#ifndef __USER_MENU_H__
#define __USER_MENU_H__

#include "User.h"
#include "WidgetID.h"

#include <qlistview.h>
#include <qpopupmenu.h>


class UserTable;
 
class UserMenu  : public QPopupMenu
{
  Q_OBJECT

public:

  typedef void (UserMenu::*UserMenuMemeberFunction)();

	UserMenu( QWidget* parent = 0, const char* name = 0 );
	virtual ~UserMenu();
  
  void setListView( UserTable* view );

signals:

  void showUsers( WidgetId id );

public slots:

  void slotViewUsers();
  void _slotViewUsers();
	void slotViewChangesBy();
	void slotSetDefaultUser();
	void slotSwitchToUser();
	void slotSetPasswordFor();
	void slotDelete();
	void slotDescribe();
	void slotEdit();
	void slotNew();

private:
  
  UserTable*         _myView;
  
};



//========================================================================
// The Widget to display the users.
//
class UserTable : public QListView 
{
  
  Q_OBJECT

public:

  UserTable( QWidget* parent = 0, const char* name = 0 ); 
  void addUser( const Perforce::User* u );

public slots:

  void onRightClick( QListViewItem*, const QPoint&, int );

private:

  int describeId;
  int switchToId;
  int viewChangesById;

  QPopupMenu* rightClickMenu;

};


#endif



