//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
//
#ifndef __VIEW_MENU_H__
#define __VIEW_MENU_H__

#include <qpopupmenu.h>

class QCheckBox;

class ViewMenu  : public QPopupMenu
{
  Q_OBJECT

public:	
  
	ViewMenu( QWidget* parent = 0, const char* name = 0 );
	virtual ~ViewMenu();

  inline int getViewUsersId() const 
    { return _usersId; }

  inline int getViewSubmittedChangeListsId( void ) const
    { return _showSubmittedChangeListsId; }

  inline int getViewPendingChangeListsId() const
    { return _showPendingChangeListsId; }

  inline int getViewBranchSpecId() const 
    { return _showBranchSpecId; }

  inline int getViewJobsId() const 
    { return _showJobsId; }

  inline int getViewLabelsId() const 
    { return _showLabelsId; }

  inline int getViewClientsId() const 
    { return _showClientSpecsId; }

public slots:

	void slotRefreshActivePane();
	void slotViewWarningsAndErrors();

	void slotOrganizeBookmarks();
	void slotAddBoomark();

	void slotShowStatusBar();
	void slotShowToolBar();

	void slotClearFilter();
	void slotFilterDepot();

	void slotEntireDepot();
	void slotLocalViewOfClientTree();
	void slotLocalViewOfDepot();
	void slotClientViewOfDepot();  	

private:

  int _usersId;

  QPopupMenu* _changeLists;
  QPopupMenu* _bookMarks;

  int _showToolBarId;
  int _showStatusBarId;
  int _showSubmittedChangeListsId;
  int _showPendingChangeListsId;
  int _showBranchSpecId;
  int _showJobsId;
  int _showLabelsId;
  int _showClientSpecsId;
};

#endif

