//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#define USE_DIALOGS_FOR_TODO 1

#if defined(USE_DIALOGS_FOR_TODO)
#include <qmessageBox.h>
#define TODO() {                                          \
  const int lineNum = __LINE__;                           \
  QString line;                                           \
  line.sprintf( "This feature is not yet implemented. \n" \
                "File: %s \n"                             \
                "Line: %d \n"                             \
                "Nice try though.", __FILE__, lineNum );  \
  QMessageBox::information( this, "qperforce", line );    \
}
#else
#include "qperforceWindow.h"
#define TODO() {                                          \
  const int lineNum = __LINE__;                           \
  QString line;                                           \
  line.sprintf( "This feature is not yet implemented. \n" \
                "File: %s \n"                             \
                "Line: %d \n"                             \
                "Nice try though.", __FILE__, lineNum );  \
  qperforceWindow* win = qperforceWindow::getInstance();  \
  win->appendUserMessage( line );                         \
}
#endif


                              
