

#include "HelpMenu.h"
#include "ConnectionInfo.h"
#include "qperforceWindow.h"
#include "todo.h"

#include <qmessagebox.h>
#include <qstringlist.h>


#ifdef WIN32
const QString HelpMenu::OS_DESCRIPTION = "MS Windows Client";
#else
const QString HelpMenu::OS_DESCRIPTION = "Unknown";
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HelpMenu::HelpMenu( QWidget* parent , const char* name ) :
  QPopupMenu( parent, name )
{
  insertItem( "Show Connection Info", this, SLOT(slotShowConnectionInfo()) );
  insertItem( "Help Topics", this, SLOT(slotHelpTopics()), Key_F1 );

  insertSeparator();

  insertItem( "Perforce Website...", this, SLOT(slotPerforceWebsite()) );
  insertItem( "Email jacobgladish@yahoo.com", this, SLOT(slotEmailSupport()) );

  insertSeparator();

  insertItem( "About...", this, SLOT(slotAbout()) );
}

HelpMenu::~HelpMenu()
{

}

void HelpMenu::slotShowConnectionInfo()
{
  Perforce::ConnectionInfo ci = Perforce::ConnectionInfo::getConnectionInfo();

  qperforceWindow* win = qperforceWindow::getInstance();
  ASSERT( win != NULL );  

  // QStringList list = QStringList::split( "\r\n", ci.getDescription() );  
  // for (QStringList::Iterator it = list.begin(); it != list.end(); ++it) {
    // prefix with 4 spaces;
   // QString msg = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + *it;
    win->appendUserMessage( ci.toString() );
  // }

}

void HelpMenu::slotHelpTopics()
{
  TODO();
}

void HelpMenu::slotPerforceWebsite()
{
  TODO();
}



void HelpMenu::slotEmailSupport()
{
  TODO();
}

void HelpMenu::slotAbout()
{
  // TODO();  
  QMessageBox::about( this, 
    "qperforce", 
    "Platform neutral gui for perforce \n"
    "revision control system."
    );
}


