//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
//
#include "SettingsMenu.h"
#include "ConfigOptionsDialogImpl.h"
#include "todo.h"


ConfigOptionsDialogImpl* SettingsMenu::_configDialog = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SettingsMenu::SettingsMenu( QWidget* parent, const char* name ) :
  QPopupMenu( parent, name )

{
  insertItem( "Options...", this, SLOT(slotOptions()) );

  insertSeparator();

  insertItem( "Use Current as Default", this, SLOT(slotUseCurrentAsDefault()) );
  insertItem( "Switch Port Client User", this, 
    SLOT(slotSwitchPortClientUser()), CTRL+Key_O );
}

SettingsMenu::~SettingsMenu()
{

}

void SettingsMenu::slotUseCurrentAsDefault()
{
  TODO();
}

void SettingsMenu::slotSwitchPortClientUser()
{
  TODO();
}

void SettingsMenu::slotOptions()
{
  if (_configDialog == NULL) {
    _configDialog = new ConfigOptionsDialogImpl( this, 
      "ConfigOptionsDialogImpl", true );
  }

  _configDialog->show();
}
