//
// QPerforce is a gui interface to the perforce revision control
// system. It is based on the qt library, and should be easily portable
// across any platform that has this toolkit available.
// 
// Copyright (C) 2002 Jacob Gladish
// 
#include "ConfigOptions.h"
#include "qperforcewindow.h"
#include "P4Client.h"
#include <qapplication.h>
#include <qmime.h>
#include <qpixmap.h>


#include "ConfigOptionsDialog.h"

void myMessageHandler( QtMsgType type, const char *msg )
{
  switch (type) {

  case QtDebugMsg:
    qperforceWindow::getInstance()->appendUserMessage( msg );
    // fprintf( stderr, "Debug: %s\n", msg );
    break;
  }
}


int main( int argc, char** argv )
{
  // qInstallMsgHandler( myMessageHandler );

	QApplication app( argc, argv );

  QPixmap p("../images/exec.png");
  QMimeSourceFactory::defaultFactory()->setPixmap( 
    "img.exec",  p);  

  qperforceWindow* window = qperforceWindow::getInstance();  
  InitialzeClient();
  window->postServerConnectInitialize();
	app.setMainWidget( window );
  window->setStatusMessage( "For Help, Press F1" );
	window->show();

	return app.exec();
}

